/*********************************************/
/*       File name:  bb0d.c                  */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ĂȂf[            */
/* N bb0d & ̂悤ɂB      */
/* NCAg bbreader.c Q    */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>

#include "bb.h"

extern void service(int soc,  char *myname);

main(int argc, char *argv[])
{
	struct sockaddr_in me;  /* ̃\PbgAhX */
	int    soc_waiting;     /* ҂󂯗p\Pbg     */
	int    soc;             /* T[rXp\Pbg     */
	pid_t  pid;             /* qvZXPID܂0 */

	/* ̃AhXsockaddr_in\̂ɐݒ */
	memset((char *)&me,  0,  sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(PORT);

	/* IPv4 ŃXg[^\Pbg쐬 */
	if((soc_waiting = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
		perror("socket");
		exit(1);
	}

	/* ̃AhX̃\Pbgւ̐ݒ */
	if(bind(soc_waiting, (struct sockaddr *)&me, sizeof(me)) == -1){
		perror("bind");
		exit(1);
	}

	/* ڑ̑҂s̒w */
	listen(soc_waiting, 5);
	fprintf(stderr, "successfully bound, now waiting.\n");

	/* [v */
	while(1){
		soc = accept(soc_waiting, NULL, NULL);

		if(( pid = fork() ) == (pid_t)0){
			/* qvZX */
			close(soc_waiting);
			service(soc, argv[0]);
			exit(0);
		}    /* qvZXI */
		else {
			/* evZX soc N[Yă[v
			   擪ɂǂ */
			close(soc);
			printf("My child [%d] now serving\n", (int)pid);
		}
	}
}
