/*********************************************/
/*       File name:  bb1d.c                  */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ̃vO͐[؂藣{̃f[ */
/* NCAg bbreader.c Q                   */
/* Iɂ kill vZXID                     */
/* ps -ax | grep bb1d Œׂ                      */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <syslog.h>
#include <signal.h>
#include <fcntl.h>

#include "bb.h"

extern void service(int soc, char *myname);
static void ending(int);

main(int argc, char *argv[])
{
	struct sockaddr_in me;  /* ̃\PbgAhX */
	int soc_waiting;        /* ҂󂯗p\Pbg     */
	int soc;                /* T[rXp\Pbg     */
	pid_t	pid;              /* qvZXPID܂0 */

	/* f[ƂĂ̎܂ł̎菇(1) */
	if(fork()!=0){
		exit(0);  /* PvZXI邱Ƃ
		             NVFɐ䂪߂B
		             qgroup leaderł͂ȂB */
	}

	/******* QvZX ********/

	/* f[ƂĂ̎܂ł̎菇(2) */
	setsid();     /* setsid֐ɂ肱̃vZX͐V
	                 session leaderA group leader
	                 ɂȂB[͎ȂB
	                 ȂAgroup leaderɂsetsid֐
	                 słȂB*/
	if(fork()!=0){
		exit(0);    /* QvZXIB
		               session leader ȂȂ̂
		               Ȍ㐧[l邱Ƃ͂Ȃ */
	}

	/******* RvZX ********/

	/* f[ƂĂ̎܂ł̎菇(3) */
	chdir("/");    /* OSIƂ
	                  umountŖfȂ */
	close(0); close(1); close(2); /* VFpł
				                     fBXNv^ */

	/*** ł̂ŁAȌAR͐ê ***/

	signal(SIGTERM, ending);
	openlog(argv[0], LOG_PID, LOG_USER);

	/* ̃AhXsockaddr_in\̂ɐݒ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(PORT);

	/* IPv4 ŃXg[^\Pbg쐬 */
	if((soc_waiting = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
		syslog(LOG_ERR, "socket failed");
		exit(1);
	}

	/* ̃AhX̃\Pbgւ̐ݒ */
	if(bind(soc_waiting, (struct sockaddr *)&me, sizeof(me)) == -1){
		syslog(LOG_ERR, "bind failed");
		exit(1);
	}

	/* ڑ̑҂s̒w */
	listen(soc_waiting, 5);
	syslog(LOG_ERR, "listen succeeded");

	/* [v */
	while(1){
		soc = accept(soc_waiting, NULL, NULL);

		if(( pid = fork() ) == (pid_t)0){
			/* qvZX */
			close(soc_waiting);
			service(soc, argv[0]);
			exit(0);
		}    /* qvZXI */
		else
			/* evZX soc N[Yă[v
			   擪ɂǂ */
			close(soc);
		syslog(LOG_ERR, "My child [%d] now serving", (int)pid);
	}
}


static void ending(int dummy){
	syslog(LOG_ERR, "service terminated");
	closelog();
	exit(0);
}
