/*********************************************/
/*       File name:  server.c                */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* [VOQ[̃T[ovO */

#include <stdio.h>
#include "race.h"
#include "mylib.h"
#include "sessionman.h"

main(int argc, char *argv[])
	/* argc     3łė~ */
	/* argv[1]  v[̐l  */
	/* argv[2]  Xe[W      */
{
	int num;              /* v[̐l    */
	int final;            /* Xe[W̐      */
	int soc_waiting;      /* listen p\Pbg */
	int maxfd;      /* \Pbg̍ő̃fBXNv^ */

	/* 3-1=2łė~ */
	if(argc != 3){
		fprintf(stderr,"Usage: s players stages\n");
		exit(1);
	}

	/* ̕ϊ   --> int  */
	if(( num = atoi(argv[1]))<=0 || num > MAX_PLAYERS ){
		fprintf(stderr,"players limit= %d\n",MAX_PLAYERS);
		exit(1);
	}
	if(( final = atoi(argv[2]))<=0 || final > MAX_STAGES ){
	  fprintf(stderr,"stage limit= %d\n",MAX_STAGES);
	  exit(1);
	}

	/* ҂󂯂̂߂̃\Pbg̍쐬 */
	if((soc_waiting = mserver_socket(PORT, num))== -1){
	  fprintf(stderr,"cannot setup server\n");
	  exit(1);
	}

	/* maccept ɃR[obN֐ enter nB
	   Ԃė͍̂ő̃fBXNv^ */
	maxfd = mserver_maccept(soc_waiting, num, enter);

	/* ZbVW[̏ */
	sessionman_init(num, final, maxfd);

	/* ZbVǗ̃C[v */
	sessionman_loop();
}
