/*********************************************/
/*       File name:  setup_mserver,c         */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int mserver_socket(in_port_t port, int backlog)
	/* ߂l   ҂󂯃\Pbg̃fBXNv^ */
	/* port     ڑ̃|[gԍ               */
	/* backlog  ҂󂯂̐                     */
{
	/* ϐ̐錾 */
	struct sockaddr_in me; /* ̃\Pbg̃AhX         */
	int soc_waiting;       /* ҂󂯃\Pbg̃fBXNv^ */

	/* ̃AhX sockaddr_in \̂ɐݒ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(port);

	/* IPv4 ŃXg[^̃\Pbg̍쐬 */
	if ((soc_waiting = socket(AF_INET,SOCK_STREAM,0)) < 0 ){
		perror("socket");
		return -1;
	}

	/* \PbgɎ̃AhXݒ */
	if (bind(soc_waiting,(struct sockaddr *)&me,sizeof(me)) == -1){
		perror("bind");
		return -1;
	}

	/* \PbgŐڑ҂̐ݒ */
	if (listen(soc_waiting, backlog) == -1){
		perror("listen");
		return -1;
	}
	fprintf(stderr,"successfully setup, now waiting.\n");

	/* ҂󂯗p̃fBXNv^Ԃ */
	return soc_waiting;
}

	/*  }`ANZvg  */

int mserver_maccept(int soc_waiting, int limit, void (*func)() )
	/* ߂l   ő̃\Pbg̃fBXNv^      */
	/* soc_waiting   ҂󂯂Ɏg\Pbg         */
	/* limit    accept ̏                       */
	/* func     accept Ɏs֐ւ̃|C^ */
{
	int i;   /* [vJE^ */
	int fd;  /* fBXNv^Ɨpϐ */

	/* accept  limit 񐔎s */
	for(i=0; i<limit; i++){
		if((fd = accept(soc_waiting, NULL, NULL))==-1){
			fprintf(stderr, "accept error\n");
			return -1;
		}
		(*func)(i, fd);
	}

	/* ҂󂯂̃\Pbg */
	close(soc_waiting);

	/* Ō fd ܂őlԂ */
	return fd;
}
