/*********************************************/
/*       File name:  setup_server6.c         */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"
#define HOSTNAME_LENGTH 64

int setup_server(in_port_t port)
	/* ߂l   \Pbg̃fBXNv^ */
	/* port     ڑ̃|[gԍ       */
{
	struct addrinfo  hints; /* ɂĒmĂ镔Iȏ    */
	struct addrinfo *res;   /* hintsɊÂʂ̊i[ꏊw */
	int soc_waiting;        /* ڑ҂̃\Pbg                    */
	int soc;                /* ʐMɎg\Pbg                    */
	char portstring[8];     /* |[gԍ̏\i                */
	char hostname[HOSTNAME_LENGTH];               /* ̃zXg  */

	/* ̃qg̐ݒ */
	gethostname(hostname, HOSTNAME_LENGTH);
	sprintf(portstring, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* Ɋւ */
	if(getaddrinfo(hostname, portstring, &hints, &res) != 0){
		perror("getaddrinfo");
		return -1;
	}

	/* IPv4 ܂ IPv6Ń\Pbg̍쐬 */
	if((soc_waiting = socket(res->ai_family,
	   res->ai_socktype, res->ai_protocol)) < 0){
		perror("socket");
		return -1;
	}

	/* \PbgɎ̃AhXݒ */
	if(bind(soc_waiting, res->ai_addr, res->ai_addrlen)!=0){
		perror("bind");
		return -1;
	}

	/* \PbgŐڑ҂̐ݒ */
	listen(soc_waiting, 1);
	fprintf(stderr, "successfully bound, now waiting.\n");

	/* ڑv܂ŃubN */
	soc = accept(soc_waiting, NULL, NULL);

	/* ڑ҂Ɏg\Pbg */
	close(soc_waiting);

	/* ɎgỈ */
	freeaddrinfo(res);

	/* ʐMɎg\Pbg̃fBXNv^Ԃ */
	return soc;
}
